﻿<template>
    <v-app>
        <v-form ref="form"
                v-model="valid"
                lazy-validation>
            <v-row>
                <v-col cols="12">
                    <v-text-field v-model="userName"
                                  readonly
                                  label="Username"></v-text-field>
                </v-col>
                <v-spacer></v-spacer>
                <v-col class="d-flex" cols="12" sm="3" xsm="12" align-end>
                    <v-btn v-if="!isCreated" :disabled="!valid"
                           color="success"
                           class="mr-4"
                           @click="onEmployeeCreate">
                        Отправить
                    </v-btn>
                </v-col>
            </v-row>
        </v-form>
    </v-app>
</template>

<script>
    import { mapActions, mapGetters } from 'vuex'

    export default {
        data() {
            return {
                valid: true,
                userId: 0,
                userName: '',
                isCreated: false
            }
        },
        created() {
            this.onEmployeeData();
            this.onUserPersonalData();
        },
        computed: {
            ...mapGetters('user', ['getUserPersonalData']),
            ...mapGetters('employee', ['getEmployeeData']),
        },
        methods: {
            ...mapActions('user', ['onUserPersonalData']),
            ...mapActions('employee', ['onEmployeeData']),
            onEmployeeCreate() {
                let userId = this.userId;
                this.$store
                    .dispatch('employee/employeeCreate',
                        {
                            userId
                        }
                    )
                    .then(() => {
                        this.$router.push({ name: 'Home' })
                    })
                    .catch()
            }
        },
        watch: {
            getUserPersonalData() {
                if (this.getUserPersonalData != undefined) {
                    this.userId = this.getUserPersonalData.id;
                    this.userName = this.getUserPersonalData.userName;
                }
            },
            getEmployeeData() {
                if (this.getEmployeeData != undefined) {
                    this.isCreated = Object.keys(this.getEmployeeData).length > 0;
                }
            }
        }
    }
</script>